'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrefetchComponent = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouterDom = require('react-router-dom');

var _defaultsDeep = require('lodash/defaultsDeep');

var _defaultsDeep2 = _interopRequireDefault(_defaultsDeep);

var _findPrefetches = require('./findPrefetches');

var _findPrefetches2 = _interopRequireDefault(_findPrefetches);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Prefetch = function (_Component) {
  _inherits(Prefetch, _Component);

  function Prefetch(props) {
    _classCallCheck(this, Prefetch);

    var _this = _possibleConstructorReturn(this, (Prefetch.__proto__ || Object.getPrototypeOf(Prefetch)).call(this, props));

    _initialiseProps.call(_this);

    _this.state = {
      initialHide: _this.props.initialHide
    };
    return _this;
  }

  _createClass(Prefetch, [{
    key: 'checkPrefetches',
    value: function checkPrefetches() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props,
          children = _ref.children,
          location = _ref.location,
          prefetchMethod = _ref.prefetchMethod;

      var createHref = this.context.router.history.createHref;


      if (!this.state.nextLocation || createHref(location) !== createHref(this.state.nextLocation)) {
        this.transitionsCount += 1;

        var context = (0, _defaultsDeep2.default)({
          router: {
            location: location
          }
        }, this.getChildContext());

        var prefetches = (0, _findPrefetches2.default)(_react2.default.createElement(
          _reactRouterDom.StaticRouter,
          {
            context: this.getChildContext(),
            location: location
          },
          _react2.default.cloneElement(children)
        ), context, prefetchMethod);

        if (prefetches.length) {
          this.setState({
            prefetches: prefetches,
            fetchRequested: true,
            nextLocation: location
          }, this.prefetchRoutes);
        } else {
          this.setState({
            initialHide: false,
            fetchRequested: false,
            location: location
          });
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          preloader = _props.preloader;
      var _state = this.state,
          fetchRequested = _state.fetchRequested,
          initialHide = _state.initialHide;


      return _react2.default.createElement(
        _react.Fragment,
        null,
        fetchRequested && preloader,
        !(fetchRequested && initialHide) && children
      );
    }
  }]);

  return Prefetch;
}(_react.Component);

Prefetch.contextTypes = {
  store: _propTypes2.default.any,
  router: _propTypes2.default.object.isRequired
};
Prefetch.childContextTypes = {
  store: _propTypes2.default.any,
  router: _propTypes2.default.object.isRequired
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.getChildContext = function () {
    return (0, _defaultsDeep2.default)({
      router: {
        route: {
          location: _this2.state.location
        }
      }
    }, _this2.context);
  };

  this.componentDidMount = this.checkPrefetches;
  this.componentWillReceiveProps = this.checkPrefetches;
  this.transitionsCount = 0;

  this.prefetchRoutes = function () {
    var _props2 = _this2.props,
        onFetchStart = _props2.onFetchStart,
        onFetchEnd = _props2.onFetchEnd,
        errorMessage = _props2.errorMessage,
        onError = _props2.onError;


    onFetchStart();

    var currentTransition = _this2.transitionsCount;

    Promise.all(_this2.state.prefetches.map(function (_ref2) {
      var _ref3 = _slicedToArray(_ref2, 2),
          getPromise = _ref3[0],
          props = _ref3[1];

      return getPromise(props);
    })).then(function () {
      if (currentTransition === _this2.transitionsCount) {
        _this2.setState({
          initialHide: false,
          prefetches: [],
          fetchRequested: false,
          location: _this2.state.nextLocation
        }, function () {
          onFetchEnd();
        });
      }
    }).catch(function (error) {
      if (currentTransition === _this2.transitionsCount) {
        _this2.setState({
          fetchRequested: false,
          prefetches: [],
          nextLocation: _this2.state.location
        }, function () {
          onError(errorMessage, error);
          onFetchEnd();
        });
      }
    });
  };
};

Prefetch.propTypes = {
  children: _propTypes2.default.node.isRequired,
  errorMessage: _propTypes2.default.string,
  initialHide: _propTypes2.default.bool,
  onError: _propTypes2.default.func.isRequired,
  onFetchStart: _propTypes2.default.func,
  onFetchEnd: _propTypes2.default.func,
  // eslint-disable-next-line react/no-unused-prop-types
  prefetchMethod: _propTypes2.default.string,
  preloader: _propTypes2.default.node
};

Prefetch.defaultProps = {
  errorMessage: 'Error while page loading',
  initialHide: true,
  onFetchStart: function onFetchStart() {},
  onFetchEnd: function onFetchEnd() {},
  prefetchMethod: 'prefetch',
  preloader: 'Loading...'
};

var PrefetchComponent = exports.PrefetchComponent = Prefetch;

exports.default = (0, _reactRouterDom.withRouter)(Prefetch);